package top.yexuejc.demo;

import top.yexuejc.demo.core.ControllerSupplier;
import top.yexuejc.demo.core.WebServer;

/**
 * web服务器入口
 *
 * @author maxiaofeng
 * @date 2025/6/19 11:11
 */
public class WebServerApplication {
    public static void main(String[] args) {
        System.setProperty("java.util.logging.SimpleFormatter.format", "%1$tY-%1$tm-%1$td %1$tH:%1$tM:%1$tS [%4$s] %2$s - %5$s%6$s%n");
        argsProcess(args);
        ControllerSupplier.builder(WebServerApplication.class);
        new WebServer().start();
    }

    /**
     * 处理参数
     * @param args
     */
    private static void argsProcess(String[] args) {
        if (args != null) {
            boolean argsCheck = true;
            for (String arg : args) {
                String[] split = arg.split("=");
                if (split.length == 2) {
                    String value = split[1];
                    switch (split[0]) {
                        case "--http.port":
                            AppConfig.put("http.port", value);
                            break;
                        case "--https.port":
                            AppConfig.put("https.port", value);
                            break;
                        case "--property":
                            try {
                                AppConfig.loadConfig(value);
                            } catch (Exception e) {
                                System.out.println("参数错误：" + arg);
                                argsCheck = false;
                            }
                            break;
                        default:
                            System.out.println("参数错误：" + arg);
                            argsCheck = false;
                            break;
                    }
                }
            }
            if (!argsCheck) {
                System.exit(0);
            }
        }
    }
}
