package top.yexuejc.demo.web;

import java.util.Map;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.json.JsonMapper;
import jakarta.validation.Valid;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import top.yexuejc.demo.model.LoginVO;

/**
 * @author maxiaofeng
 * @date 2025/7/3 16:37
 */
@Controller
@RequestMapping("/login")
public class LoginCtrl {

    private static final Logger log = LoggerFactory.getLogger(LoginCtrl.class);

    @GetMapping("")
    public ModelAndView page(ModelAndView mv, @RequestParam Map<String, Object> params) {
        mv.addAllObjects(params);
        mv.setViewName("login");
        return mv;
    }

    @GetMapping("/get")
    public String loginGet(@Valid LoginVO loginVO) throws JsonProcessingException {
        log.info(new JsonMapper().writeValueAsString(loginVO));
        return "redirect:/";
    }

    @PostMapping(value = "/postJson", consumes = MediaType.APPLICATION_JSON_VALUE)
    public String loginPostJson(@RequestBody @Validated LoginVO loginVO) throws JsonProcessingException {
        log.info(new JsonMapper().writeValueAsString(loginVO));
        return "redirect:/";
    }

    @PostMapping(value = "/postFrom", consumes = MediaType.APPLICATION_FORM_URLENCODED_VALUE)
    public String loginPostFrom(@Validated LoginVO loginVO) throws JsonProcessingException {
        log.info(new JsonMapper().writeValueAsString(loginVO));
        return "redirect:/";
    }
}
